"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.runWebpackCore = void 0;
const common_1 = require("../types/common");
const webpack_1 = require("../service/builder/webpack");
function runWebpackCore({ mainAppData, subAppDataList, appBuildDir, materialsDir, cb, mpConfig, dependencies, nodeModulesPath, publicPath, mode, watch, appKey, buildTypeList, generateMpType, generateMpPath, plugins, assets = [], }) {
    return __awaiter(this, void 0, void 0, function* () {
        console.time('runWebpackCore');
        console.time('webpackGenerate');
        const allAppDataList = subAppDataList.concat(mainAppData);
        const webWebpackConfigPath = yield webpack_1.generateWebpackWebBuildParamsFile({
            appId: mainAppData.id || appKey,
            allAppDataList,
            appBuildDir,
            materialsDir,
            dependencies,
            nodeModulesPath,
            publicPath,
            mode,
            watch,
            buildTypeList,
            assets,
        });
        console.timeEnd('webpackGenerate');
        const taskList = [];
        console.time('generateMpJsonConfigFile');
        yield webpack_1.generateMpJsonConfigFile(allAppDataList, mpConfig, appBuildDir, plugins, {
            appKey,
            generateMpType,
        });
        console.timeEnd('generateMpJsonConfigFile');
        if (common_1.buildAsWebByBuildType(buildTypeList)) {
            yield webpack_1.generateWebpackWebDevServerFile({
                appBuildDir,
                buildTypeList,
            });
            webpack_1.startCompile({
                appBuildDir,
                configPath: webWebpackConfigPath,
                appKey,
            }, cb);
        }
        console.time('webpackCompile');
        yield Promise.all(taskList);
        console.timeEnd('webpackCompile');
        console.timeEnd('runWebpackCore');
    });
}
exports.runWebpackCore = runWebpackCore;
