"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getWxmlTag = exports.extractUsedCompsRecursively = exports.installMaterials = void 0;
const path = __importStar(require("path"));
const util_1 = require("util");
const fs = __importStar(require("fs-extra"));
const weapps_core_1 = require("../../weapps-core");
const config_1 = require("../config");
const mp_1 = require("../config/mp");
const util_2 = require("../util");
const util_3 = require("./util");
const wxml_1 = require("./wxml");
const generateFiles_1 = __importDefault(require("../util/generateFiles"));
const lowcode_1 = require("./lowcode");
const net_1 = require("../util/net");
const util_4 = require("../util");
const junk = __importStar(require("../util/junk"));
const templateDir = config_1.appTemplateDir + '/mp/';
function installMaterials(projDir, usedComps, weapps, ctx) {
    return __awaiter(this, void 0, void 0, function* () {
        let { materialLibs } = ctx;
        const weappsList = ctx.isMixMode
            ? weapps
            : weapps.filter((item) => !item.rootPath);
        const localPkg = util_2.getCurrentPackageJson();
        yield Promise.all(materialLibs
            .filter((lib) => !lib.isComposite && usedComps[lib.name])
            .map((lib) => __awaiter(this, void 0, void 0, function* () {
            const { name, version, mpPkgUrl } = lib;
            let materialsSrcDir = '';
            const materialId = `${name}@${version}`;
            if (localPkg && localPkg.name === name) {
                materialsSrcDir = path.join(process.cwd(), 'build', 'mp');
            }
            else {
                materialsSrcDir = path.join(config_1.sharedMaterialsDir, `${name}-mp@${version}`);
                yield downloadMaterial(mpPkgUrl, materialsSrcDir);
            }
            function libUpdated(libDir, version) {
                const meta = util_4.readComponentLibMata(libDir);
                if (!meta) {
                    return true;
                }
                if (meta.version !== lib.version) {
                    return true;
                }
            }
            const usingMaterialMap = {};
            yield Promise.all(weappsList.map((app) => __awaiter(this, void 0, void 0, function* () {
                const targetDir = path.join(projDir, config_1.materialsDirName, name);
                if (usingMaterialMap[targetDir]) {
                    return;
                }
                else {
                    usingMaterialMap[targetDir] = true;
                }
                const materialsSrcDirPath = path.join(materialsSrcDir, 'src');
                let dirsToDelete = [];
                let compGroupIndexJson = {};
                let componentsJsonUsed = {};
                if (libUpdated(targetDir, version)) {
                    if (fs.existsSync(materialsSrcDirPath)) {
                        console.log(`Copying material ${materialId} from ${materialsSrcDir}/src to ${targetDir}`);
                        const metaJosnPath = path.join(materialsSrcDir, 'meta.json');
                        if (fs.existsSync(metaJosnPath)) {
                            yield fs.copy(metaJosnPath, path.join(targetDir, 'meta.json'));
                        }
                        yield fs.copy(materialsSrcDirPath, targetDir, {
                            filter: function (src, dest) {
                                return !junk.is(path.basename(src));
                            },
                        });
                    }
                    else {
                        console.log(`Copying material ${materialId} from ${materialsSrcDir} to ${targetDir}`);
                        yield fs.copy(materialsSrcDir, targetDir, {
                            filter: function (src, dest) {
                                return !junk.is(path.basename(src));
                            },
                        });
                    }
                }
                const libMeta = util_4.readComponentLibMata(targetDir);
                if (!lib.components) {
                    lib.components = Object.keys((libMeta === null || libMeta === void 0 ? void 0 : libMeta.components) || {}).map((name) => {
                        var _a;
                        return ({
                            name,
                            meta: (_a = libMeta === null || libMeta === void 0 ? void 0 : libMeta.components[name]) === null || _a === void 0 ? void 0 : _a.meta,
                        });
                    });
                }
                lib.styles = libMeta === null || libMeta === void 0 ? void 0 : libMeta.styles;
                lib.dependencies = libMeta === null || libMeta === void 0 ? void 0 : libMeta.dependencies;
            })));
        })));
        materialLibs = ctx.materialLibs.filter((lib) => usedComps[lib.name]);
        ctx.materialLibs = materialLibs;
        materialLibs.map((lib) => {
            lib.components = lib.components.filter((comp) => usedComps[lib.name].has(comp.name));
        });
        materialLibs.map((lib) => {
            lib.components.map((comp) => {
                comp.materialName = lib.name;
            });
        });
        const compositedLibs = materialLibs.filter((lib) => lib.isComposite && usedComps[lib.name]);
        compositedLibs.map((lib) => {
            lib.dependencies = lib.dependencies || {};
            lib.components.map((cmp) => {
                cmp.meta.syncProps = {};
                const { dataForm = {} } = cmp;
                for (const prop in dataForm) {
                    const { inputProp, syncProp } = dataForm[prop];
                    if (syncProp || inputProp) {
                        cmp.meta.syncProps[prop] = syncProp || inputProp;
                    }
                }
                cmp.meta.platforms = {
                    mp: {
                        path: cmp.name + '/index',
                    },
                };
                lib.dependencies = Object.assign(Object.assign({}, lib.dependencies), cmp.npmDependencies);
            });
        });
        compositedLibs.map((lib) => __awaiter(this, void 0, void 0, function* () {
            console.log('Generate composited library ' + lib.name);
            yield util_4.writeLibCommonRes2file(lib, path.join(ctx.projDir, config_1.materialsDirName, lib.name, 'libCommonRes'));
            return lib.components.map((cmp) => {
                weappsList.forEach((app) => {
                    generateCompositeComponent(cmp, Object.assign({}, ctx), lib.compLibCommonResource);
                });
            });
        }));
    });
}
exports.installMaterials = installMaterials;
function extractUsedCompsRecursively(comps, checkedComps, compositedLibs, outputComps) {
    let usedComps = (outputComps || comps);
    const libsUsedByApp = Object.keys(comps);
    libsUsedByApp.forEach((libName) => {
        const cmpNames = comps[libName];
        const lib = compositedLibs.find((lib) => lib.name == libName);
        if (!lib || !lib.isComposite)
            return;
        cmpNames.forEach((cmpName) => {
            const cmp = lib.components.find((c) => c.name === cmpName);
            if (!cmp) {
                console.warn('Component not found', libName + ':' + cmpName);
                return;
            }
            if (checkedComps.indexOf(cmp) > -1)
                return;
            checkedComps.push(cmp);
            const cmpsUsedByThisComp = wxml_1.getUsedComponents(cmp.componentInstances);
            const libs = Object.keys(cmpsUsedByThisComp);
            libs.forEach((libName) => {
                if (!usedComps[libName]) {
                    usedComps[libName] = cmpsUsedByThisComp[libName];
                }
                else {
                    cmpsUsedByThisComp[libName].forEach((n) => usedComps[libName].add(n));
                }
            });
            extractUsedCompsRecursively(cmpsUsedByThisComp, checkedComps, compositedLibs, usedComps);
        });
    });
    return usedComps;
}
exports.extractUsedCompsRecursively = extractUsedCompsRecursively;
function downloadMaterial(zipUrl, dstFolder) {
    return __awaiter(this, void 0, void 0, function* () {
        if (fs.existsSync(path.join(dstFolder, 'meta.json')))
            return;
        yield net_1.downloadZip(zipUrl, dstFolder);
    });
}
function generateCompositeComponent(compositedComp, ctx, compLibCommonResource) {
    return __awaiter(this, void 0, void 0, function* () {
        const { materialName } = compositedComp;
        const outDir = path.join(ctx.projDir, ctx.rootPath || '', config_1.materialsDirName, materialName, compositedComp.name);
        console.log(`Generating composited component ${materialName}:${compositedComp.name} to ${outDir}`);
        const wxmlDataPrefix = mp_1.getWxmlDataPrefix(!ctx.isProduction);
        const usingComponents = {};
        const cmpContainer = Object.values(compositedComp.componentInstances)[0];
        const wxml = wxml_1.generateWxml(compositedComp.componentInstances, 'Component ' + materialName + ':' + compositedComp.name, wxmlDataPrefix, Object.assign(Object.assign({}, ctx), { isPage: false }), usingComponents, (cmp, node) => {
            if (cmp === cmpContainer) {
                const { attributes } = node;
                const classAttrName = mp_1.getClassAttrName(node.name);
                const oldClass = attributes[classAttrName];
                attributes[classAttrName] =
                    weapps_core_1.getCompositedComponentClass(compositedComp) +
                        ' ' +
                        oldClass +
                        ' {{className}}';
                attributes.style += ';{{style}}';
            }
        });
        const { syncProps } = compositedComp.meta;
        const formEvents = {};
        Object.keys(syncProps).map((prop) => {
            const config = syncProps[prop];
            const configs = Array.isArray(config) ? config : [config];
            configs.forEach(({ changeEvent, valueFromEvent, isFormField }) => {
                if (isFormField) {
                    formEvents[changeEvent] = valueFromEvent;
                }
            });
        });
        const pageFileData = {
            'index.js': {
                materialName: materialName,
                propDefs: compositedComp.dataForm,
                handlers: compositedComp.lowCodes
                    .filter((m) => m.type === 'handler-fn' && m.name !== '____index____')
                    .map((m) => m.name),
                eventHandlers: util_3.createEventHanlders(compositedComp.componentInstances, weapps_core_1.COMPONENT_API_PREFIX, ctx),
                emitEvents: compositedComp.emitEvents.map((evt) => evt.eventName),
                widgetProps: util_3.createWidgetProps(compositedComp.componentInstances, ctx),
                compApi: weapps_core_1.COMPONENT_API_PREFIX,
                jsonSchemaType2jsClass: mp_1.jsonSchemaType2jsClass,
                key: compositedComp.materialName + ':' + compositedComp.name,
                dataBinds: util_3.createDataBinds(compositedComp.componentInstances, ctx),
                debug: !ctx.isProduction,
                stringifyObj: util_1.inspect,
                formEvents: Object.keys(formEvents).length > 0 ? formEvents : null,
                config: compositedComp.compConfig,
            },
            'index.json': { usingComponents },
            'index.wxml': {
                content: wxml,
            },
            'index.wxss': {},
        };
        yield generateFiles_1.default(pageFileData, templateDir + '/component', outDir, ctx);
        const codes = [...compositedComp.lowCodes];
        if (!codes.find((m) => m.name === 'index')) {
            codes.push({
                code: 'export default {}',
                name: 'index',
                path: 'index',
            });
        }
        codes
            .filter((mod) => mod.name !== '____index____')
            .map((mod) => {
            let themeCode;
            if (mod.type === 'style' && compLibCommonResource) {
                themeCode = `
         ${compLibCommonResource.theme.variable || ''}
         ${compLibCommonResource.class || ''}
         ${compLibCommonResource.theme.class || ''}
      `;
            }
            return lowcode_1.writeCode2file(mod, path.join(outDir, 'lowcode'), { comp: compositedComp }, themeCode, ctx);
        });
    });
}
function getWxmlTag(cmp, ctx, nameMangler) {
    var _a, _b, _c, _d, _e, _f;
    const { moduleName, name } = cmp;
    const materialLib = ctx.materialLibs.find((lib) => lib.name === moduleName);
    const miniprogramPlugin = (_a = ctx.miniprogramPlugins) === null || _a === void 0 ? void 0 : _a.find((plugin) => plugin.name === moduleName);
    let tagName = name.toLocaleUpperCase();
    let compPath;
    const components = (materialLib === null || materialLib === void 0 ? void 0 : materialLib.components) || (miniprogramPlugin === null || miniprogramPlugin === void 0 ? void 0 : miniprogramPlugin.componentConfigs);
    const findComponent = components === null || components === void 0 ? void 0 : components.find((comp) => comp.name === name);
    if (!findComponent) {
        return { tagName };
    }
    if (materialLib) {
        let cmpMeta = (findComponent === null || findComponent === void 0 ? void 0 : findComponent.meta) || { platforms: undefined };
        if (!cmpMeta.platforms) {
            return { tagName };
        }
        compPath = (_c = (_b = cmpMeta === null || cmpMeta === void 0 ? void 0 : cmpMeta.platforms) === null || _b === void 0 ? void 0 : _b.mp) === null || _c === void 0 ? void 0 : _c.path;
        if ((_e = (_d = cmpMeta === null || cmpMeta === void 0 ? void 0 : cmpMeta.platforms) === null || _d === void 0 ? void 0 : _d.mp) === null || _e === void 0 ? void 0 : _e.tagName) {
            tagName = (_f = cmpMeta === null || cmpMeta === void 0 ? void 0 : cmpMeta.platforms) === null || _f === void 0 ? void 0 : _f.mp.tagName;
        }
        if (compPath) {
            const rootPath = ctx.rootPath || '';
            compPath = compPath.startsWith('/')
                ? compPath
                : path.posix.join('', `/${config_1.materialsDirName}/${cmp.moduleName}`, compPath);
            tagName = `${moduleName}-${name}`;
            if (nameMangler) {
                tagName = nameMangler.mangle(tagName);
            }
        }
    }
    else {
        compPath = `plugin://${miniprogramPlugin === null || miniprogramPlugin === void 0 ? void 0 : miniprogramPlugin.name}/${name}`;
        tagName = `${moduleName}-${name}`;
        if (nameMangler) {
            tagName = nameMangler.mangle(tagName);
        }
    }
    if (!tagName) {
        tagName = name.toLocaleUpperCase();
    }
    return {
        tagName,
        path: compPath,
    };
}
exports.getWxmlTag = getWxmlTag;
