"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.mergePages = exports.mergePackageDependiences = exports.mergePackageJson = exports.mergeSubPackages = void 0;
const fs = __importStar(require("fs-extra"));
const lodash_1 = __importDefault(require("lodash"));
function mergeSubPackages(baseAppJsonPath, mergeAppJsonPath) {
    return __awaiter(this, void 0, void 0, function* () {
        const baseJson = fs.readJSONSync(baseAppJsonPath);
        const mergeJson = fs.readJSONSync(mergeAppJsonPath);
        if (!getSubPackages(mergeJson))
            return;
        const newJson = Object.assign({}, baseJson);
        if (!baseJson.subpackages) {
            newJson.subpackages = getSubPackages(mergeJson);
        }
        else {
            getSubPackages(mergeJson).forEach((mergeItem) => {
                const targetItemIdx = newJson.subpackages.findIndex((item) => {
                    return item.root === mergeItem.root;
                });
                if (newJson.subpackages[targetItemIdx]) {
                    const pages = lodash_1.default.uniq([].concat(newJson.subpackages[targetItemIdx].pages, mergeItem.pages));
                    newJson.subpackages[targetItemIdx].pages = pages;
                }
                else {
                    newJson.subpackages.push(mergeItem);
                }
            });
        }
        fs.writeJSONSync(baseAppJsonPath, newJson, { spaces: 2 });
        function getSubPackages(json) {
            return json.subpackages || json.subPackages;
        }
    });
}
exports.mergeSubPackages = mergeSubPackages;
function mergePackageJson(basePkgJsonPath, mergePkgJsonPath) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!(yield fs.pathExists(basePkgJsonPath))) {
            yield fs.copy(mergePkgJsonPath, basePkgJsonPath);
        }
        else {
            let baseJson = fs.readJSONSync(basePkgJsonPath);
            const mergeJson = fs.readJSONSync(mergePkgJsonPath);
            baseJson = Object.assign(Object.assign({}, baseJson), mergePackageDependiences(baseJson, mergeJson));
            yield fs.writeJSON(basePkgJsonPath, baseJson, { spaces: 2 });
        }
    });
}
exports.mergePackageJson = mergePackageJson;
function mergePackageDependiences(baseJson, mergeJson) {
    baseJson.dependencies = Object.assign(Object.assign({}, (baseJson.dependencies || {})), (mergeJson.dependencies || {}));
    baseJson.devDependencies = Object.assign(Object.assign({}, (baseJson.devDependencies || {})), (mergeJson.devDependencies || {}));
    return baseJson;
}
exports.mergePackageDependiences = mergePackageDependiences;
function mergePages(baseAppJsonPath, mergeAppJsonPath) {
    return __awaiter(this, void 0, void 0, function* () {
        const baseJson = fs.readJSONSync(baseAppJsonPath);
        const mergeJson = fs.readJSONSync(mergeAppJsonPath);
        baseJson.pages = lodash_1.default.uniq([
            ...(baseJson.pages || []),
            ...(mergeJson.pages || []),
        ]);
        yield fs.writeJSON(baseAppJsonPath, baseJson, { spaces: 2 });
    });
}
exports.mergePages = mergePages;
