"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.genCompositeComponentLibraries = exports.generateDefaultLowcodeIndex = exports.writeLowCodeFilesForCompositeComp = exports.runHandleMaterial = void 0;
const path = __importStar(require("path"));
const weapps_core_1 = require("../../weapps-core");
const util_1 = require("../util");
const generate_1 = require("./generate");
const template_1 = __importDefault(require("../template"));
const json_schema_defaults_1 = __importDefault(require("json-schema-defaults"));
const lodash_template_1 = __importDefault(require("lodash.template"));
const lodash_uniqby_1 = __importDefault(require("lodash.uniqby"));
const style_1 = require("../util/style");
const lodash_1 = require("lodash");
function runHandleMaterial(appBuildDir, dependencies = [], i18nConfig, fileCodeMap, isSandbox) {
    return __awaiter(this, void 0, void 0, function* () {
        yield handleCompositeComponent({
            dependencies,
            appBuildDir,
            i18nConfig,
            fileCodeMap,
            isSandbox,
        });
    });
}
exports.runHandleMaterial = runHandleMaterial;
function handleCompositeComponent({ dependencies, appBuildDir, i18nConfig, fileCodeMap, isSandbox, }) {
    return __awaiter(this, void 0, void 0, function* () {
        const compositeDependencies = dependencies.filter((item) => item.isComposite);
        const materialGroupInfoMap = {};
        dependencies.forEach((item) => (materialGroupInfoMap[item.name] = {
            isComposite: item.isComposite,
            version: item.version,
            entries: item.entries,
            schemaVersion: item.schemaVersion,
        }));
        console.log('=====================================*****', materialGroupInfoMap);
        const componentsInfoMap = yield util_1.getComponentsInfo(path.join(appBuildDir, 'src'), dependencies, fileCodeMap);
        yield writeLowCodeFilesForCompositeComp(compositeDependencies, appBuildDir, fileCodeMap, isSandbox);
        yield genCompositeComponentLibraries(compositeDependencies, appBuildDir, materialGroupInfoMap, componentsInfoMap, i18nConfig, fileCodeMap, isSandbox);
    });
}
function writeLowCodeFilesForCompositeComp(compositeGroups, appBuildDir, fileMap, isSandbox) {
    return __awaiter(this, void 0, void 0, function* () {
        yield Promise.all(compositeGroups.map((gItem) => __awaiter(this, void 0, void 0, function* () {
            const common = yield util_1.writeLibCommonRes2file(gItem, path.join(appBuildDir, 'src', 'libraries', `${gItem.name}@${gItem.version}`, 'libCommonRes'));
            Object.assign(fileMap, common);
            const compLibCommonResource = gItem.compLibCommonResource;
            let themeCode = '';
            if (compLibCommonResource) {
                themeCode = `
          ${compLibCommonResource.theme.variable || ''}
          ${compLibCommonResource.class || ''}
          ${compLibCommonResource.theme.class || ''}
        `;
            }
            yield Promise.all(gItem.components.map((cItem) => __awaiter(this, void 0, void 0, function* () {
                generateDefaultLowcodeIndex(cItem);
                return cItem.lowCodes.map((m) => __awaiter(this, void 0, void 0, function* () {
                    const filePath = path.join(appBuildDir, 'src', 'libraries', `${gItem.name}@${gItem.version}`, 'components', cItem.name, 'lowcode');
                    cItem.materialName = gItem.name;
                    const fileItem = yield writeCode2file(m, filePath, cItem, themeCode, isSandbox);
                    Object.assign(fileMap, fileItem);
                    return fileMap;
                }), {});
            })));
            return fileMap;
        })));
        return fileMap;
        function writeCode2file(mod, lowcodeDir, comp, themeCode, isSandbox) {
            return __awaiter(this, void 0, void 0, function* () {
                const pageId = comp.name + '_' + comp.id;
                const file = path.join(lowcodeDir, weapps_core_1.getCodeModuleFilePath(pageId, mod, {
                    style: '.css',
                }));
                let codeContent = '';
                if (mod.type === 'style') {
                    codeContent = yield style_1.processLess(`.${weapps_core_1.getCompositedComponentClass(comp)} { \n${themeCode ? themeCode : ''}\n${mod.code}\n }`);
                }
                else {
                    const importApp = !isSandbox
                        ? `import { app } from '/src/app/global-api'`
                        : `const app = new Proxy({}, {
          get: function(obj, prop){ return window.app ? window.app[prop] : undefined},
          set: function(obj, prop, value){ if(window.app) {return  window.app[prop] = value} else {return undefined } }
        })`;
                    codeContent = `${importApp}
      const $app = app;
      ${mod.code.replace(/\$comp/g, 'this.$WEAPPS_COMP')};`;
                }
                return {
                    [file]: {
                        code: codeContent,
                    },
                };
            });
        }
    });
}
exports.writeLowCodeFilesForCompositeComp = writeLowCodeFilesForCompositeComp;
function generateDefaultLowcodeIndex(data) {
    const lowCodes = data.lowCodes || data.codeModules || [];
    const fileTypes = ['index', 'style', 'state', 'lifecycle', 'computed'];
    fileTypes.map((type) => {
        const isHasLowcodeIndex = lowCodes.find((item) => item.type === type);
        if (!isHasLowcodeIndex) {
            const code = {
                type: type,
                name: type,
                code: type === 'style' ? '' : `export default {}`,
                path: `$comp_1/${type}`,
            };
            lowCodes.unshift(code);
            return code;
        }
    });
}
exports.generateDefaultLowcodeIndex = generateDefaultLowcodeIndex;
function genCompositeComponentLibraries(dependencies = [], appBuildDir, materialGroupInfoMap = {}, componentsInfoMap, i18nConfig, fileMap, isSandbox) {
    return __awaiter(this, void 0, void 0, function* () {
        yield Promise.all(dependencies.map(({ name, version, components }) => __awaiter(this, void 0, void 0, function* () {
            const materialNameVersion = `${name}@${version}`;
            const librariesDir = path.join(appBuildDir, 'src/libraries', materialNameVersion);
            yield Promise.all(components.map((compItem) => __awaiter(this, void 0, void 0, function* () {
                compItem.materialName = name;
                const wrapperClass = weapps_core_1.getCompositedComponentClass(compItem);
                const componentSchemaJson = {
                    type: 'object',
                    properties: weapps_core_1.readCmpInstances(compItem.componentInstances),
                };
                const { widgets, dataBinds, componentSchema, } = generate_1.getComponentSchemaString(componentSchemaJson, true, componentsInfoMap, wrapperClass);
                const templateData = {
                    id: compItem.id,
                    name: compItem.name,
                    defaultProps: json_schema_defaults_1.default({
                        type: 'object',
                        properties: compItem.dataForm || {},
                    }),
                    compConfig: compItem.compConfig || {},
                    emitEvents: JSON.stringify(compItem.emitEvents.map((evt) => evt.eventName)),
                    handlersImports: compItem.lowCodes.filter((codeItem) => codeItem.type === 'handler-fn' &&
                        codeItem.name !== '____index____'),
                    useComponents: (function () {
                        const list = [];
                        JSON.stringify(compItem.componentInstances, (key, value) => {
                            var _a;
                            if (key === 'xComponent') {
                                const { moduleName, name } = value;
                                const compLib = materialGroupInfoMap[moduleName];
                                let isPlainProps = false;
                                if (compLib) {
                                    const { schemaVersion = '' } = compLib;
                                    try {
                                        if (Number((_a = schemaVersion.split('.')) === null || _a === void 0 ? void 0 : _a[0]) >= 3) {
                                            isPlainProps = true;
                                        }
                                    }
                                    catch (e) { }
                                }
                                list.push({
                                    moduleName,
                                    name,
                                    key: `${moduleName}:${name}`,
                                    var: lodash_1.upperFirst(util_1.camelcase(`${moduleName}:${name}`)),
                                    moduleNameVar: util_1.camelcase(moduleName),
                                    version: compLib === null || compLib === void 0 ? void 0 : compLib.version,
                                    isComposite: compLib === null || compLib === void 0 ? void 0 : compLib.isComposite,
                                    isPlainProps,
                                    entries: compLib === null || compLib === void 0 ? void 0 : compLib.entries,
                                });
                            }
                            return value;
                        });
                        return lodash_uniqby_1.default(list, 'key');
                    })(),
                    widgets,
                    dataBinds,
                    componentSchema,
                    pageListenerInstances: generate_1.getListenersString(compItem.listeners, true),
                    materialName: name,
                    hasComponentAPI: compItem.lowCodes.some((item) => item.type === 'index'),
                    isSandbox,
                };
                const dest = path.resolve(librariesDir, `./components/${compItem.name}/index.jsx`);
                const template = template_1.default['/src/pages/composite.tpl'].code;
                try {
                    const jsx = lodash_template_1.default(template, { interpolate: /<%=([\s\S]+?)%>/g })(templateData);
                    fileMap[dest] = {
                        code: jsx,
                    };
                }
                catch (e) {
                    console.error('>>> template', template, e);
                }
            })));
        })));
        return fileMap;
    });
}
exports.genCompositeComponentLibraries = genCompositeComponentLibraries;
